﻿@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using System.Web.UI.WebControls;
@using System.Reflection;

@{
    LayoutPageModel model = Model.GetModel<LayoutPageModel>();
    IHtmlComponent cmpDataGrid = model.GetControl(MaintenanceController.AREA_DATAGRID);
    Dictionary<string,string> keyMap = ViewBag.KeyMap;
    string dataValues = String.Empty;
    foreach(string value in keyMap.Values) {
        dataValues += value;
    }
    
    if (cmpDataGrid != null)
    {
        HtmlDataGridComponent dataGrid = ((HtmlDataGridComponent)cmpDataGrid).DetailGrid;        
        @Html.DevExpress().GridView(
                settings =>
                {
                    settings.Name = HtmlComponentHelper.GenerateComponentId(dataGrid) + dataValues;
                    settings.KeyFieldName = dataGrid.KeyFieldName;
                    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
                    settings.CallbackRouteValues = new { Controller = (string)ViewBag.ScreenId, Action = "DetailGrid", keys = ServiceStack.Text.JsonSerializer.SerializeToString<Dictionary<string,string>>(keyMap) };
                    settings.ClientSideEvents.BeginCallback = "OnBeginUpdateSearchResult";
                    settings.ClientSideEvents.EndCallback = "OnEndUpdateSearchResult";

                    settings.CommandColumn.Visible = true;
                    settings.CommandColumn.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                    settings.CommandColumn.ButtonType = System.Web.UI.WebControls.ButtonType.Image;
                    settings.ClientSideEvents.CustomButtonClick = "CommandButtonClicked";
                    GridViewCommandColumnCustomButton editButton = new GridViewCommandColumnCustomButton();
                    editButton.ID = "btEdit";
                    editButton.Image.Url = "~/Content/Images/Common/Edit.png";
                    settings.CommandColumn.CustomButtons.Add(editButton);
                    GridViewCommandColumnCustomButton deleteButton = new GridViewCommandColumnCustomButton();
                    deleteButton.ID = "btDelete";
                    deleteButton.Image.Url = "~/Content/Images/Common/Delete.png";
                    settings.CommandColumn.CustomButtons.Add(deleteButton);
                    
                    settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(35);

                    settings.SettingsEditing.UpdateRowRouteValues = new { Controller = (string)ViewBag.ScreenId, Action = "Update" };
                    settings.SettingsEditing.DeleteRowRouteValues = new { Controller = (string)ViewBag.ScreenId, Action = "Delete" };
                    settings.SettingsEditing.AddNewRowRouteValues = new { Controller = (string)ViewBag.ScreenId, Action = "Insert" };
                    settings.SettingsEditing.NewItemRowPosition = 0;

                    settings.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                    settings.Columns.Add("Selected", "#", MVCxGridViewColumnType.CheckBox);
                    List<IHtmlComponent> columnComponents = dataGrid.Columns;
                    if (columnComponents.Count > 0)
                    { 
                        int cntColumns = columnComponents.Count;
                        IHtmlComponent column;
                        for (int i = 0; i < cntColumns; i++)
                        { 
                            column = columnComponents[i];
                            settings.Columns.Add(column.GetId(), column.GetName());
                        }
                    }

                    int rowCount = 0;
                    object key;
                    string selectionClass;
                    settings.SetDataItemTemplateContent(c =>
                    {
                        if (columnComponents.Count > 0)
                        {
                            string fieldName = c.Column.FieldName;
                            if (fieldName.Equals("Selected"))
                            {
                                key = DataBinder.Eval(c.DataItem, "SelectedKeyValue");
                                selectionClass = "SelectionCheckbox";
                                if (c.Grid.Selection.IsRowSelectedByKey(key))
                                {
                                    selectionClass = "SelectionCheckbox-Selected";
                                }
                                ViewContext.Writer.WriteLine(
                                    string.Format("<div id='{0}-{1}' class='{2}' onclick=\"toggleSelectionCheckbox(this);\"/>", HtmlComponentHelper.GenerateComponentId(string.Format("Selected{0}", ++rowCount), typeof(HtmlBooleanComponent)), key, selectionClass)
                                );
                            }

                            int cntColumns = columnComponents.Count;
                            IHtmlComponent column;
                            string id;
                            string componentId;
                            for (int i = 0; i < cntColumns; i++)
                            {
                                column = columnComponents[i];
                                id = column.GetId();                                
                                
                                if(fieldName.Equals(id))
                                {
                                    if (column.GetType() == typeof(HtmlUploadComponent))
                                    {
                                        componentId = "detail_" + HtmlComponentHelper.GenerateComponentId(string.Format("{0}{1}", id, rowCount), typeof(HtmlImageComponent));                                        
                                        Html.DevExpress().BinaryImage(
                                            imageSettings => {
                                                imageSettings.Name = componentId;
                                                imageSettings.Properties.ClientSideEvents.Init = "function(s,e) { cmInitImagePreviewMenu(\"" + componentId + "\"); }";
                                            }
                                        ).Bind(DataBinder.Eval(c.DataItem, id)).Render();                                        
                                    }
                                    else {
                                        Html.DevExpress().Label(
                                            controlSettings =>
                                            {
                                                controlSettings.Name = "detail_" + HtmlComponentHelper.GenerateComponentId(string.Format("{0}{1}", id, rowCount), typeof(HtmlLabelComponent));
                                            }
                                        ).Bind(DataBinder.Eval(c.DataItem, id)).Render();
                                    }
                                }
                            }
                        }                        
                    });
                    settings.Columns["Selected"].Width = Unit.Pixel(15);

                    string[] keyFraction = dataGrid.KeyFieldName.Split(';');
                    List<string> keys = new List<string>();
                    foreach (string k in keyFraction)
                    {
                        keys.Add(k.Trim());
                    }
                    settings.SetEditFormTemplateContent(c => {
                        ViewContext.Writer.WriteLine("<div class='editTemplate'>");
                        ViewContext.Writer.WriteLine("<div class='editTemplateFormSection'>");
                        ViewContext.Writer.WriteLine("<table>");
                        ExtensionBase extension;
                        EditorExtension editorExtension;
                        Type editorType = typeof(EditorExtension);
                        foreach (IHtmlComponent comp in dataGrid.Columns)
                        {
                            if (keys.Contains(comp.GetId()))
                            {
                                continue;
                            }
                            
                            ViewContext.Writer.WriteLine("<tr>");
                            ViewContext.Writer.WriteLine("<td>");
                            @Html.DevExpress().Label(
                                editSettings =>
                                {
                                    editSettings.Name = "lbl" + comp.GetId();
                                    editSettings.Text = comp.GetName();
                                    editSettings.ControlStyle.CssClass = "dxInlineDisplay";
                                    editSettings.ControlStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                                }
                            ).Render();
                            ViewContext.Writer.WriteLine("</td>");
                            ViewContext.Writer.WriteLine("<td>");
                            extension = Html.cmGetDevExpressComponent(comp);
                            if (extension != null)
                            {
                                if (editorType.IsInstanceOfType(extension))
                                {
                                    editorExtension = (EditorExtension)extension;
                                    editorExtension.Bind(DataBinder.Eval(c.DataItem, comp.GetId()));
                                }
                                extension.Render();
                            }
                            ViewContext.Writer.WriteLine("</td>");
                            ViewContext.Writer.WriteLine("</tr>");
                        }
                        ViewContext.Writer.WriteLine("</table>");
                        ViewContext.Writer.WriteLine("</div>");

                        ViewContext.Writer.WriteLine("<div class='editTemplateButtonsSection'>");
                        @Html.DevExpress().Button(
                            editSettings => { 
                                editSettings.Name = "btSaveUpdate";
                                editSettings.Text = "Save";
                                editSettings.Width = System.Web.UI.WebControls.Unit.Pixel(100);
                                editSettings.ControlStyle.CssClass = "editTemplateButton";
                                editSettings.ClientSideEvents.Click = "UpdateEdit";
                            }
                        ).Render();
                        @Html.DevExpress().Button(
                            editSettings =>
                            {
                                editSettings.Name = "btCancelUpdate";
                                editSettings.Text = "Cancel";
                                editSettings.Width = System.Web.UI.WebControls.Unit.Pixel(100);
                                editSettings.ControlStyle.CssClass = "editTemplateButton";
                                editSettings.ClientSideEvents.Click = "CancelEditing";
                            }
                        ).Render();
                        ViewContext.Writer.WriteLine("</div>");
                        ViewContext.Writer.WriteLine("</div>");
                    });
                }
        ).Bind(dataGrid.DataSource).GetHtml()
    }
}
